package com.supermap.imb.appconfig;

import android.app.Application;
import android.util.Log;
import android.view.Gravity;
import android.widget.Toast;

import com.supermap.android.file.MyAssetManager;
import com.supermap.android.file.MySharedPreferences;
import com.supermap.data.Environment;
import com.supermap.data.Workspace;
import com.supermap.data.WorkspaceConnectionInfo;
import com.supermap.data.WorkspaceType;

public class MyApplication extends Application {
	public static String DATAPATH = "";
	public static String SDCARD = android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+"/";
	private static MyApplication sInstance = null;
	private Workspace mWorkspace = null;
	
	@Override
	public void onCreate() {
		// TODO Auto-generated method stub
		super.onCreate();
		
		DATAPATH = this.getFilesDir().getAbsolutePath()+"/";
		sInstance = this;
		
		//Set the environment parameters first
		Environment.setLicensePath(DefaultDataConfig.LicensePath);
		Environment.initialization(this);
		Environment.setOpenGLMode(false);
//		Environment.setOpenGLMode(false);
		
		//Initializes the classes related with system.
		MySharedPreferences.init(this);
		MyAssetManager.init(this);
		
		//Config data
//		new DefaultDataConfig().autoConfig();
		mWorkspace = new Workspace();
//		openWorkspace();
//		mWorkspace = new Workspace();
		
	}

	public void openWorkspace() {
		WorkspaceConnectionInfo info = new WorkspaceConnectionInfo();
		info.setServer(DefaultDataConfig.WorkspacePath);
		info.setType(WorkspaceType.SMWU);
		if(!mWorkspace.open(info)){
			ShowError("Workspace is damaged!");
		}
	}
	
	/**
	 * Get the opened workspace
	 * @return
	 */
	public Workspace getOpenedWorkspace(){
		return mWorkspace;
	}
	
	/**
	 * Get current application
	 * @return
	 */
	public static MyApplication getInstance(){
		return sInstance;
	}
	
	/**
	 * Display information
	 */
	public void ShowInfo(String info){
		Toast toast = Toast.makeText(sInstance, info, 500);
		toast.setGravity(Gravity.CENTER_VERTICAL|Gravity.CENTER_HORIZONTAL, 0, 0);
		toast.show();
	}
	
	/**
	 * Display the error information
	 * @param err
	 */
	public void ShowError(String err){
		Toast toast = Toast.makeText(sInstance, "Error: "+err, 500);
		toast.setGravity(Gravity.CENTER_VERTICAL|Gravity.CENTER_HORIZONTAL, 0, 0);
		toast.show();
		Log.e(this.getClass().getName(), err);
	}
	
	/**
	 * Get the display size
	 * @param dp
	 * @return
	 */
	public static int dp2px(int dp){
		return (int) (dp*sInstance.getResources().getDisplayMetrics().density);
	}
}
