package com.supermap.imb.collectordemo;

import java.util.ArrayList;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.DialogInterface.OnMultiChoiceClickListener;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.location.LocationManager;
import android.os.Bundle;
import android.view.GestureDetector;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.widget.ListView;
import android.widget.RadioButton;
import android.widget.Toast;

import com.supermap.data.CoordSysTransMethod;
import com.supermap.data.CoordSysTransParameter;
import com.supermap.data.CoordSysTranslator;
import com.supermap.data.Dataset;
import com.supermap.data.Datasource;
import com.supermap.data.DatasourceConnectionInfo;
import com.supermap.data.EngineType;
import com.supermap.data.GeoStyle;
import com.supermap.data.GeometryType;
import com.supermap.data.Point2D;
import com.supermap.data.Point2Ds;
import com.supermap.data.PrjCoordSys;
import com.supermap.data.PrjCoordSysType;
import com.supermap.data.Rectangle2D;
import com.supermap.data.Workspace;
import com.supermap.imb.appconfig.DefaultDataConfig;
import com.supermap.imb.collectordemo.R;
import com.supermap.mapping.Action;
import com.supermap.mapping.EditStatusListener;
import com.supermap.mapping.FinishEditedEvent;
import com.supermap.mapping.GeometrySelectedEvent;
import com.supermap.mapping.GeometrySelectedListener;
import com.supermap.mapping.Map;
import com.supermap.mapping.MapControl;
import com.supermap.mapping.MapView;
import com.supermap.mapping.ScaleType;
import com.supermap.mapping.ScaleView;
import com.supermap.mapping.SnapMode;
import com.supermap.mapping.SnapSetting;
import com.supermap.mapping.collector.CollectionChangedListener;
import com.supermap.mapping.collector.Collector;
import com.supermap.mapping.collector.CollectorElement.GPSElementType;
import com.supermap.mapping.dyn.DynamicCircle;
import com.supermap.mapping.dyn.DynamicElement;
import com.supermap.mapping.dyn.DynamicPoint;
import com.supermap.mapping.dyn.DynamicStyle;
import com.supermap.mapping.dyn.DynamicView;
import com.supermap.plugin.LocationChangedListener;
import com.supermap.plugin.LocationManagePlugin;
import com.supermap.plugin.LocationManagePlugin.GPSData;
/**
 * <p>
 * Title:GPS Collector
 * </p>
 * 
 * <p>
 * Description:
 * ============================================================================>
 * ------------------------------Statement----------------------------
 * This is for SuperMap iMobile for Android Sample Code 
 * Copyright: SuperMap Software Co., Ltd.
 * ----------------------------------------------------------------
 * ---------------------SuperMap iMobile for Android Sample Code------------------------
 * 
 * 1. Function
 *   (1)Open/Close collector
 *   (2)Collect point/line/region object
 *   (3)Set the style/property for the collector object
 *   (4)Nodes edit the collector object
 * ------------------------------------------------------------------------------
 * ============================================================================>
 * </p> 
 * 
 * <p>
 * Company: SuperMap Software Co., Ltd.
 * </p>
 * 
 */
public class MainActivity extends Activity implements OnClickListener, OnTouchListener{
	private MapView mMapView = null;
	private MapControl mMapControl = null;
	private DynamicView mDynamicView = null;
	private Map mMap = null;
	private ScaleView mScaleView = null;
	private Collector collector = null;
	private SettingPopup m_SettingPopup = null;

	//Type
	String strType;
	//Type list
	ListView listview;

	//System azimuth
	private SensorManager mSensorManager;
	private Sensor mSensorOrientation;
	/*private*/ float mAzimuth = 0;
	/*private*/ Point2D mPoint2D = new Point2D(0, 0);//(116.499861111,39.9833333333)
	/*private*/ double mAccuracy = 0;
	
	LocationIMB m_MyLocation = null;
	Point2D mCurrentPnt2D = new Point2D(0, 0);//0,0
	//Calculate the degree correspond with 30 meters range
	final public double dUnit = 2.694945898329385 * 2 * Math.pow(10, -4);
    //Plane coordinate conversion  Unit: m/degree 
    final public double dReverseUnit = 111319.489;//6378137*2*3.1415926 / 360
    int mDynPolygonID = -1;
    int mDynPointID = -1;
    DynamicCircle mDynGeoCircle = null;
    DynamicPoint mDynGeoPoint = null;
	
	// Receive focus
	private RadioButton mBtnReceiveFocus = null;
	private View  anchorView = null;
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
//	    // Remove the status bar on the Activity
//	    getWindow().setFlags(WindowManager.LayoutParams. FLAG_FULLSCREEN, WindowManager.LayoutParams. FLAG_FULLSCREEN);
        
        initUI();
        prepareData();
       
        //mMapControl.setMagnifierEnabled(true);
        mMapControl.setOnTouchListener(this);
    }
    
    /*
     * Prepare the map data
     */
	private void prepareData(){
		final ProgressDialog progress = new ProgressDialog(this);
		progress.setCancelable(false);
		progress.setMessage("Loading...");
		progress.setProgressStyle(android.R.style.Widget_ProgressBar_Large);
		progress.show();
		new Thread(){
			@Override
			public void run() {
				super.run();
				////Config data
				//new DefaultDataConfig().autoConfig();
				runOnUiThread(new Runnable() {
					@Override
					public void run() {
						progress.dismiss();
						
//						MyApplication.getInstance().openWorkspace();
//						mMapControl.getMap().setWorkspace(MyApplication.getInstance().getOpenedWorkspace());
//					    mMapControl.getMap().open(MyApplication.getInstance().getOpenedWorkspace().getMaps().get(0));
////					    mMapControl.getMap().open(MyApplication.getInstance().getOpenedWorkspace().getMaps().get(1));
//					    mMapControl.getMap().setFullScreenDrawModel(true);
//					    mMapControl.getMap().refresh();
						
						//Config data
						new DefaultDataConfig().autoConfig();
						
						//OpenStreetMap
						openOSM();
						
						//open collector udb
						openCollectorUDB();
						
					}
				});
			}
		}.start();
	}
    /**
     * Initialize interface
     */
    private void initUI(){
    	//MapView mapView =  (MapView) findViewById(R.id.mapView);
    	//mMapControl = mapView.getMapControl();
    	mMapView = (MapView) findViewById(R.id.mapView);
    	mMapControl = mMapView.getMapControl();
    	mMap = mMapControl.getMap();
    	
    	mDynamicView = new DynamicView(this, mMapControl.getMap());
    	mMapView.addDynamicView(mDynamicView);

    	
    	//Topology editing
    	findViewById(R.id.btnObject0).setOnClickListener(this);
    	findViewById(R.id.btnObject).setOnClickListener(this);
    	findViewById(R.id.btnObject2).setOnClickListener(this);
    	findViewById(R.id.btnObject2_1).setOnClickListener(this);
    	findViewById(R.id.btnObject3).setOnClickListener(this);
    	findViewById(R.id.btnObject4).setOnClickListener(this);
    	findViewById(R.id.btnObject5).setOnClickListener(this);
    	
    	
    	//GPS collect
    	findViewById(R.id.btnControlDisplay2).setOnClickListener(this);
    	findViewById(R.id.btnControlDisplay3).setOnClickListener(this);
    	findViewById(R.id.btnControlDisplay3_1).setOnClickListener(this);
    	findViewById(R.id.btnControlDisplay3_2).setOnClickListener(this);
    	findViewById(R.id.btnControlDisplay4).setOnClickListener(this);
    	findViewById(R.id.btnControlDisplay5).setOnClickListener(this);
    	findViewById(R.id.btnControlDisplay6).setOnClickListener(this);
    	findViewById(R.id.btnControlDisplay7).setOnClickListener(this);


    	//Add A GestureDetector To MapControl 
    	initGesture();
    	
//    	//initialize the collector
//    	initCollector();
    	
    	//initialize the location
    	initLocate();
    	
    	//open Snap Mode
    	initSnap();
    	
    	//initialize the ScaleView
    	initScaleView();
    	
    	//Add a GeometryselectedListenter to MapControl
    	mMapControl.addGeometrySelectedListener(new GeometrySelectedListener() {
			
			@Override
			public void geometrySelected(GeometrySelectedEvent event) {
				// TODO Auto-generated method stub
				
				System.out.println("Selected ID: " + event.getGeometryID());
			}
			
			@Override
			public void geometryMultiSelected(ArrayList<GeometrySelectedEvent> events) {
				// TODO Auto-generated method stub

			}
		});
    	
    	//Add a EditStatusListener to MapControl
    	mMapControl.setEditStatusListener( new EditStatusListener() {
			
			@Override
			public void deleteNodeEnable(boolean isEnable) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void addNodeEnable(boolean isEnable) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void finishGeometryEdited(FinishEditedEvent event) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void beforeFinishGeometryEdited(FinishEditedEvent arg0) {
				// TODO Auto-generated method stub
				
			}
		});
    	
    }
    
    /**
     * open OpenStreetMap
     */
    private void openOSM(){
		Workspace workspace = new Workspace();
    	mMapView = (MapView) findViewById(R.id.mapView);
    	mMapControl = mMapView.getMapControl();
        mMap = mMapControl.getMap();
    	
        mMap.setWorkspace(workspace);
    	
		//OpenStreetMap
		String url = "http://openstreetmap.org";
		DatasourceConnectionInfo info = new DatasourceConnectionInfo();
		info.setAlias("OpenStreetMap2");
		info.setEngineType(EngineType.OpenStreetMaps);
		info.setServer(url);
		
		Datasource datasource = workspace.getDatasources().open(info);
		if(datasource != null){
			mMap.getLayers().add(datasource.getDatasets().get(0), true);
		}

		Rectangle2D bound = new Rectangle2D(12968258.504923185, 4862779.700006611, 12969117.62508615, 4864134.068308002);
		mMap.setViewBounds(bound);
		mMap.refresh();
    }
    
    /**
     * Open datasource
     */
    private void openCollectorUDB(){
    	//String sdcard = android.os.Environment.getExternalStorageDirectory().getAbsolutePath()+"/";
    	//String path = sdcard + "SampleData/SnapData/" + "gpscollector.udb";
    	String path = DefaultDataConfig.WorkspacePath;
    	
        Workspace workspace = mMap.getWorkspace();//new Workspace();
		DatasourceConnectionInfo info = new DatasourceConnectionInfo();
		info.setEngineType(EngineType.UDB);
		info.setServer(path);
		
		//open the datasource
		Datasource datasource = workspace.getDatasources().open(info);
		
		if(datasource != null){
			mMap.getLayers().add(datasource.getDatasets().get(0), true);
		}

    	//initialize the collector
		initCollector();
		//Rectangle2D bound = datasource.getDatasets().get(0).getBounds();
		//mMap.setViewBounds(bound);
		mMap.refresh();
    }
    
	@Override
	public void onClick(View v) {
		switch (v.getId()) {

		//Submit object
		case R.id.btnObject0:
			mMapControl.submit();
			mMapControl.setAction(Action.PAN);
			break;
		//Add object
		case R.id.btnObject:
			mMapControl.setAction(Action.CREATEPOLYGON);
			mMapControl.getMap().getLayers().get(0).setEditable(true);
			break;
		//Delete object
		case R.id.btnObject2:
			mMapControl.deleteCurrentGeometry();
			mMapControl.setAction(Action.SELECT);
			break;
		//Select object
		case R.id.btnObject2_1:
			mMapControl.setAction(Action.SELECT);
			break;
		//Positioning
		case R.id.btnObject3:
			//mMapControl.setAction(Action.SELECT_BY_RECTANGLE);
			if(collector != null){				
				//Current position coordinate
				Point2D point2D = new Point2D(mPoint2D.getX(), mPoint2D.getY());//collector.getGPSPoint();
				
				//Valid coordinate
				if( !(point2D.getX() == 0 && point2D.getY() == 0) ){
					//If the projection is not longitude and latitude coordinate system, projection conversion to point is needed.
					PrjCoordSys Prj = mMap.getPrjCoordSys();
					if (Prj.getType() != PrjCoordSysType.PCS_EARTH_LONGITUDE_LATITUDE) {
						Point2Ds points = new Point2Ds();
						points.add(point2D);
						PrjCoordSys desPrjCoorSys = new PrjCoordSys();
						desPrjCoorSys.setType(PrjCoordSysType.PCS_EARTH_LONGITUDE_LATITUDE);
						CoordSysTranslator.convert(points, desPrjCoorSys, Prj,
								new CoordSysTransParameter(),
								CoordSysTransMethod.MTH_GEOCENTRIC_TRANSLATION);
			
						point2D.setX(points.getItem(0).getX());
						point2D.setY(points.getItem(0).getY());
					}
	
					//Add the positioning point
					mMapControl.panTo(point2D, 300);
				}//if
			}
			break;
		case R.id.btnObject4:
			mMapControl.redo();
			break;
		case R.id.btnObject5:
			mMapControl.undo();
			break;
		
		//GPS collector
		case R.id.btnControlDisplay2:
			{
				//Get the data acquisition module
				collector = mMapControl.getCollector();
				
				//Saving the dataset of acquisition object, it can be point, line, region, CAD.
				Dataset dataset = mMapControl.getMap().getLayers().get(0).getDataset();
				collector.setDataset(dataset);
				
				collector.openGPS();
				
//				collector.createElement(GPSElementType.POINT);
				collector.createElement(GPSElementType.LINE);
//				collector.createElement(GPSElementType.POLYGON);

				//Style
				GeoStyle geoStyle = new GeoStyle();
				com.supermap.data.Color color = new com.supermap.data.Color(110, 208, 254);
				//Line color 
				geoStyle.setLineColor(color);
				//Set the drawing style
				collector.setStyle(geoStyle);
				
				//Enable the single tap
				collector.setSingleTapEnable(true);
				//collector.closeGPS();
			}
			break;
		case R.id.btnControlDisplay3:
			if(collector != null){
				listview = new ListView(getApplicationContext());
				String[] StringArrays = new String[] { "Point", "Line", "Region" };
				final boolean[] areaStates = new boolean[] { false, false, false };
				AlertDialog builder = new AlertDialog.Builder(this)
						.setTitle("Select type")
						.setMultiChoiceItems(StringArrays, areaStates,
								new OnMultiChoiceClickListener() {

									@Override
									public void onClick(DialogInterface dialog,
											int which, boolean isChecked) {
									}
								})
						.setPositiveButton("OK", new DialogInterface.OnClickListener() {

							public void onClick(DialogInterface dialog, int id) {
								for (int i = 0; i < areaStates.length; i++) {
									if (listview.getCheckedItemPositions().get(i)) {
										if(i == 0){
											collector.createElement(GPSElementType.POINT);
											strType = "Point";
										}
										else if(i == 1){
											collector.createElement(GPSElementType.LINE);
											strType = "Line";
										}
										else if(i == 2){
											collector.createElement(GPSElementType.POLYGON);
											strType = "Region";
										}
									}
								}
								
								mMapControl.getMap().refresh();
								Toast.makeText(getApplicationContext(), "Create " + strType + " object",
										Toast.LENGTH_SHORT).show();
							}
						}).setNegativeButton("Cancel", null).create();
				listview = builder.getListView();
				builder.show();
			}
			break;
		//Positioning collector
		case R.id.btnControlDisplay3_1:
			if(collector != null){
				////Add positioning point
				//collector.addGPSPoint();
				
				//Current positioning coordinate
				Point2D point2D = new Point2D(mPoint2D.getX(), mPoint2D.getY());//collector.getGPSPoint();
				
				//Valid coordinate
				if( !(point2D.getX() == 0 && point2D.getY() == 0) ){
					//If the projection is not longitude and latitude coordinate system, projection conversion to point is needed.
					PrjCoordSys Prj = mMap.getPrjCoordSys();
					if (Prj.getType() != PrjCoordSysType.PCS_EARTH_LONGITUDE_LATITUDE) {
						Point2Ds points = new Point2Ds();
						points.add(point2D);
						PrjCoordSys desPrjCoorSys = new PrjCoordSys();
						desPrjCoorSys.setType(PrjCoordSysType.PCS_EARTH_LONGITUDE_LATITUDE);
						CoordSysTranslator.convert(points, desPrjCoorSys, Prj,
								new CoordSysTransParameter(),
								CoordSysTransMethod.MTH_GEOCENTRIC_TRANSLATION);
			
						point2D.setX(points.getItem(0).getX());
						point2D.setY(points.getItem(0).getY());
					}
	
					//Add the positioning point
					collector.addGPSPoint(point2D);
				}//if
			}
			break;
		//Edit setting
		case R.id.btnControlDisplay3_2:
			if(m_SettingPopup == null){
		    	m_SettingPopup = new SettingPopup(mMapControl, collector, this);
			}
	    	m_SettingPopup.setFocusable(true);
	    	m_SettingPopup.show();
			break;
		//Rollback
		case R.id.btnControlDisplay4:
			if(collector != null){
				collector.undo();
			}
			break;
		//Redo
		case R.id.btnControlDisplay5:
			if(collector != null){
				collector.redo();
			}
			break;
		//Submit
		case R.id.btnControlDisplay6:
			if(collector != null){
				collector.submit();
			}
			break;
		//Tap screen 
		case R.id.btnControlDisplay7:
			if(collector != null){
				if(collector.IsSingleTapEnable() == false){
					collector.setSingleTapEnable(true);
				}
				else{
					collector.setSingleTapEnable(false);
				}
			}
		default:
			break;
		}		
	}  
	
	@Override
	public boolean onTouch(View v, MotionEvent event) {
		// TODO Auto-generated method stub
		mMapControl.onMultiTouch(event);
		 
		int action = event.getAction();
		
		// Submit automatically after drawing the point object
		if(action == MotionEvent.ACTION_UP){
			if (mMapControl.getCurrentGeometry() != null && mMapControl.getCurrentGeometry().getType()==GeometryType.GEOPOINT) {
				
				mMapControl.submit();

				return true;
			}
		}
			
		return true;	
	}
	
	
	/**
	 * Register the gesture listener for the map control
	 */
	void initGesture()
	{		
        //Add the gesture listener for current map
		GestureDetector gestureDetector = new GestureDetector(mMapControl.getContext(), new GestureDetector.SimpleOnGestureListener() {
			//Clicking map can't trigger the translation. 
			@Override
			public boolean onSingleTapUp(MotionEvent e){
				if(collector != null){
//					//Current screen position
//					float eventX = e.getX();
//					float eventY = e.getY();
//					Point2D pnt2D = mMapControl.getMap().pixelToMap(new Point((int)eventX, (int)eventY));
//					Point pntMotion = new Point((int)e.getX(), (int)e.getY());
//					collector.addPoint(pntMotion);
//					collector.addGPSPoint(pnt2D);
				}

				return true;
			}
		});
		
		//Set the gesture listener of mapControl
		mMapControl.setGestureDetector(gestureDetector);
	}

	/**
	 * Initialize positioning module
	 */
	private void initLocate(){
		mSensorManager = (SensorManager)getSystemService(Context.SENSOR_SERVICE);
		mSensorOrientation = mSensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION);
		startSensor();

		//Tencent positioning
		m_MyLocation = new LocationIMB(this);
	}
	
	/**
	 * Initialize the collector
	 */
	private void initCollector(){
		//Get the module for data acquisition
		collector = mMapControl.getCollector();
		
		//Saving the dataset of acquisition object, it can be point, line, region, CAD.
		Dataset dataset = mMapControl.getMap().getLayers().get(0).getDataset();
		collector.setDataset(dataset);
		
		collector.openGPS();
		
		//Create line object
		collector.createElement(GPSElementType.LINE);
		
		//Style
		GeoStyle geoStyle = new GeoStyle();
		//Line color
		com.supermap.data.Color color = new com.supermap.data.Color(0,110,220);//(220,110,245);
		geoStyle.setLineColor(color);
		//Region color
		com.supermap.data.Color colorFore = new com.supermap.data.Color(160,255,90);//(160,255,160);
		geoStyle.setFillForeColor(colorFore);
		//Set the drawing style
		collector.setStyle(geoStyle);
		
//		//Enable the single tap
//		collector.setSingleTapEnable(true);
		//Add the listener for the change of positioning
		collector.setCollectionChangedListener(mCollectionChangedListener);
	}
	
	/**
	 * Enable the snap function
	 */
	private void initSnap(){
		SnapSetting snapSetting = new SnapSetting();
		//Save all snap patterns
		com.supermap.data.Enum[] snapModes = com.supermap.data.Enum.getEnums(SnapMode.class);
		//All snap patterns are invalid
		for (int j = 0; j < snapModes.length; j++) {
			snapSetting.set((SnapMode) snapModes[j], false);
		}

//		
//			snapSetting.set(SnapMode.POINT_ON_ENDPOINT, true);
//	
//			snapSetting.set(SnapMode.POINT_ON_POINT, true);
//
//			snapSetting.set(SnapMode.POINT_ON_LINE, true);
		//Enable the default snap pattern
		snapSetting.openDefault();
		
		//Snap setting
		mMapControl.setSnapSetting(snapSetting);
		//Refresh map
		mMapControl.getMap().refresh();
	}

	/**
	 * Prompt message
	 * @param info
	 */
	public void showInfo(String info)
	{
		Toast toast = Toast.makeText(this, info, Toast.LENGTH_SHORT);
		toast.setGravity(Gravity.CENTER_VERTICAL|Gravity.CENTER_HORIZONTAL, 0, 0);
		toast.show();
	}
	

	/**
	 * Start to monitor the change
	 */
	public void startSensor(){
		if (mSensorManager != null && mSensorOrientation != null) {
			mSensorManager.registerListener(mSensorEventListener, mSensorOrientation, SensorManager.SENSOR_DELAY_UI);
		}
	}
	/**
	 * Stop to monitor the change
	 */
	public void stopSensor(){
		if (mSensorManager != null && mSensorOrientation != null) {
			mSensorManager.unregisterListener(mSensorEventListener, mSensorOrientation);
		}
	}
	//Positioning current location
	public void locate(Point2D pt){
		//The timer is shifted to the current position
		mMapControl.panTo(pt, 20);
		
//		//Clear all dynamic object
//		mDynamicView.clear();
//		
//		DynamicPoint dynElement = new DynamicPoint();
//		dynElement.addPoint(pt);
//		DynamicStyle style = new DynamicStyle();
//		style.setBackground(BitmapFactory.decodeResource(mMapControl.getResources(), R.drawable.navi_popup_small));
//		dynElement.setStyle(style);
//		mDynamicView.addElement(dynElement);
//		
//		//Specify the dynamic object and add animation
//		DynamicElement element = mDynamicView.query(dynElement.getID());
//		if(element != null){
//			element.addAnimator(new ZoomAnimator(2.0f, 400));
//			element.addAnimator(new ZoomAnimator(0.5f, 400));
//		}
//		mDynamicView.startAnimation();
	}
	
	/**
	 *  Initialize the scale control
	 */
	private void initScaleView(){
		mScaleView = (ScaleView) findViewById(R.id.scaleView);
		mScaleView.setMapView(mMapView);
		mScaleView.setLevelEnable(true);
		mScaleView.setScaleType(ScaleType.Chinese);
	}
	
	public Map getMap(){
		return mMapControl.getMap();
	}

	
	public void drawCircleOnDyn(Point2D pnt2D, float dAzimuth, double dAccuracy){
		//copy another point2D
		Point2D point2D = new Point2D(pnt2D.getX(), pnt2D.getY());
		if(point2D.getX() == 0 && point2D.getY() == 0){
			System.out.println("Unable to draw position.");
			return;
		}
		if(mDynamicView == null || mMapControl == null){
			return;
		}

		//If the projection is not longitude and latitude coordinate system, projection conversion to point is needed.
		PrjCoordSys Prj = mMapControl.getMap().getPrjCoordSys();
		if (Prj.getType() != PrjCoordSysType.PCS_EARTH_LONGITUDE_LATITUDE) {
			Point2Ds points = new Point2Ds();
			points.add(point2D);
			PrjCoordSys desPrjCoorSys = new PrjCoordSys();
			desPrjCoorSys.setType(PrjCoordSysType.PCS_EARTH_LONGITUDE_LATITUDE);
			CoordSysTranslator.convert(points, desPrjCoorSys, Prj,
					new CoordSysTransParameter(),
					CoordSysTransMethod.MTH_GEOCENTRIC_TRANSLATION);

			point2D.setX(points.getItem(0).getX());
			point2D.setY(points.getItem(0).getY());
		}
		//Positioning accuracy
		if(dAccuracy <= 0 || dAccuracy > 500){  //Invalid accuracy range
			dAccuracy = dUnit;//Default radius is 60m.
		}
		else{
			dAccuracy = 60;//dUnit * (m_MyLocation.getAccuracy() / 60.0);
		}
		
		//Add dynamic object
		if(mDynPointID == -1 && mDynPolygonID == -1){
			DynamicCircle dynGeoCircle = new DynamicCircle();
			dynGeoCircle.addPoint(new Point2D(point2D.getX(), point2D.getY()));
			dynGeoCircle.setRadius(dAccuracy/*100*//*mMapControl.getMap().getBounds().getWidth() / 100000*/);//Unit: m
			
			DynamicStyle styleGeCircle  = new DynamicStyle();
			styleGeCircle.setAlpha(60);
			styleGeCircle.setBackColor(Color.rgb(255, 255, 255));//52, 168, 83
			styleGeCircle.setSize(5);
			styleGeCircle.setLineColor(Color.rgb(51, 129, 204));//172, 52, 48
			dynGeoCircle.setStyle(styleGeCircle);
			mDynamicView.addElement(dynGeoCircle);
			mDynGeoCircle = dynGeoCircle;
			mDynPolygonID = dynGeoCircle.getID();

			//Draw the central point
			DynamicPoint dynPoint = new DynamicPoint();
			dynPoint.addPoint(point2D);
			DynamicStyle dynStyle = new DynamicStyle();
			dynStyle.setBackground(BitmapFactory.decodeResource(mMapControl.getResources(), R.drawable.navi_popup_small_2_1));
			dynStyle.setAngle(dAzimuth);
			dynPoint.setStyle(dynStyle);
			
			mDynamicView.addElement(dynPoint);
			mDynGeoPoint = dynPoint;
			mDynPointID = dynPoint.getID();
			
			mDynamicView.refresh();
		}
		//Modify dynamic object
		else{
			//Draw center circle
			mDynGeoCircle.setPoint(new Point2D(point2D.getX(), point2D.getY()));
			mDynGeoCircle.setRadius(dAccuracy);//Unit: m
			
			//Draw center point
			DynamicStyle dynStyle = new DynamicStyle();
			dynStyle.setBackground(BitmapFactory.decodeResource(mMapControl.getResources(), R.drawable.navi_popup_small_2_1));
			dynStyle.setAngle(dAzimuth);
			mDynGeoPoint.setPoint(point2D);
			mDynGeoPoint.setStyle(dynStyle);
			
			mDynamicView.refresh();
		}
		
	}
	
	private CollectionChangedListener mCollectionChangedListener = new CollectionChangedListener() {
		
		@Override
		public void collectionChanged(Point2D pnt2d, double dAccuracy) {
			mPoint2D.setX(pnt2d.getX());
			mPoint2D.setY(pnt2d.getY());
			mAccuracy = dAccuracy;
			
			//Draw current positioning location
			drawCircleOnDyn(mPoint2D, mAzimuth, mAccuracy);
			showInfo("Position changes");
		}
	};


	
	/**
	 * When the phone azimuth has changed, the listener is triggered
	 */
	private SensorEventListener mSensorEventListener = new SensorEventListener() {
		
		@Override
		public void onSensorChanged(SensorEvent event) {
			// TODO Auto-generated method stub
			if (event.sensor.getType() == Sensor.TYPE_ORIENTATION) {
				if (Math.abs(mAzimuth - event.values[0])<3) {
					return;
				}
				//Update current azimuth
				mAzimuth = event.values[0];
				
				//Draw current positioning location
				drawCircleOnDyn(mPoint2D, mAzimuth, mAccuracy);
			}
		}
		
		@Override
		public void onAccuracyChanged(Sensor sensor, int accuracy) {
			// TODO Auto-generated method stub
			
		}
	};
	
	/**
	 * To determine whether it is editing now.
	 * @return
	 */
	private boolean isEditting() {
		
		Action action= mMapControl.getAction();
		if(action.equals(Action.PAN) || action.equals( Action.NULL)){
			return false;
		}else{
		    return true;
		}
	}
	
	private void closeLocateion(){
		stopSensor();
	}
	
}